breed [customers customer]
breed [retailers retailer]

customers-own
[
 p1
 p2
 p3
 requirement
 customer-utility

]

retailers-own
[
  unit-purchase-cost-C1
  unit-inventory-cost-C2
  order-fixed-cost-O
  income
  quantity
  asset
  time
  alpha
  cost
  inventory
  beita
  product-value
  price
  price_1
  profit
  x

  reward
  reward-1
  reward-2
  Q-table-value
  utility-d
  utility-p
  utility-q
  utility
  Q-price

  serve
  standard-inventory
  profit-table
  max-Q-table
  Q-table-1
  utility-1
  pprice
  ppprice
  possible_1
  possible_2
  possible_3
  reward_1
  reward_4
  order-1
  product-value-2
  average-profit
  total-cost
]

globals
[
  demand
  tm1
  tm2
  action
  action1
  price-queue
  tem_10
  tem
  tem-1
  tem-2
  max-function
  demand-1
  demand-2
  demand-3
  demand-4
  dmax_1
  Q-table
]

to setup
  clear-all
  set-default-shape retailers "house"
  set-default-shape customers "person"
  ;
 create-retailers 4
 [
   set size 2
   setxy random-xcor random-ycor
   set unit-purchase-cost-C1 5.5
   set unit-inventory-cost-C2 0.4
   set order-fixed-cost-O 200
   set alpha 0.01
   set beita 0.005
   set product-value 1
   set total-cost 0
 ]
 ; create 6 retailers
 
 ask retailer 0
 [
   set color red
   set income 0
   set quantity 800
   set asset quantity
   set time 0
   setxy 0 8 
 ]
 
 ask retailer 1
 [
   set color green
   set income 0
   set quantity 800
   set asset quantity
   set time 0
   setxy 0 -8 
 ]
 
 ask retailer 2
 [
   set color yellow
   set income 0
   set quantity 800
   set asset quantity
   set time 0
   setxy -8 0 
 ]
 
 ask retailer 3
 [
   set color white
   set income 0
   set quantity 800
   set asset quantity
   set time 0
   setxy 8 0
   set profit-table [0 0 0 0 0 0 0 0 0 0 0 0 0] 
   set Q-table-1 [0 0 0 0 0 0 0 0 0 0 0 0 0]
   set reward_1 [0 0]
 ] 
 
 
 create-customers customers-1
 [
   set color red
 ]
 
 create-customers customers-2
 [
   set color green
 ]
 
 create-customers customers-3
 [
   set color blue
 ]
 

 
 set demand 0
 set tem -1
 set tem-2 -1
 ask customers
 [setxy random-xcor random-ycor]
 set action1 [-1 0 1]
 set Q-table [[0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0 0] [0 0]]
 set price-queue [6 6.5 7 7.5 8 8.5 9 9.5 10 10.5 11 11.5 12]

 reset-ticks
end
 
to go

  ask customers
  [
    set requirement (random-normal 300 100)
    set requirement requirement / 100
    if requirement < 0 [set requirement 0]
    set customer-utility [0 0 0 0]
  ]
   
  ask retailer 0
  [
    perform-strategy0
  ]
  
  ask retailer 1
  [
    perform-strategy1
  ]
  
  ask retailer 2
  [
    perform-strategy2
  ]
  
  ask retailer 3
  [
    perform-strategy3
  ]
 
  ask customers
  [
    move
  ]
  
  ask retailers
  [
    serve-customers
    calculate-profit
    replenish
  ]
  
  ask retailers
  [
    update-Q-table
  ]
  
  ask customers
  [
    leave
  ]

  tick
  
  ask retailers [set time time + 1]
end

to perform-strategy0
  ask retailer 0
  [
    set product-value exp(-1 * alpha * time)
    set price retailer-0-price
  ]
end


to perform-strategy1
  ask retailer 1
  [
    set product-value exp(-1 * alpha * time)
    set product-value-2 exp(-1 * 0.1 * time)
    set price retailer-1-price-1 * product-value-2 + retailer-1-price-2
  ]
end

to perform-strategy2
  ask retailer 2
  [
    let customers-4 (customers-1 + customers-2 + customers-3) / 4
    let customers-5 customers-4 * 3
    let customers-6 quantity / customers-5
    set product-value exp(-1 * alpha * time)
    set standard-inventory (1 - time / customers-6) * quantity
    set price retailer-2-price-1 + retailer-2-price-2 * (1 - asset / standard-inventory)
    if price < 6
    [set price 6]
    if price > 11
    [set price 11]
  ]
end

to perform-strategy3
  ask retailer 3
  [
    set product-value exp(-1 * alpha * time)
  ]
  Q-learning
end


to serve-customers
  ask retailers 
  [
    set serve customers-here
    if serve != nobody 
     [
       set x  sum [requirement] of customers-here
       if asset > 0
       [
         ifelse asset -(asset + asset - x) * beita - x > 0
         [
          set income price * x   
          set inventory  (asset + asset -(asset + asset - x) * beita - x) / 2
          set cost (order-fixed-cost-O / quantity + unit-purchase-cost-C1) * (x + (asset + asset - x) * beita) + unit-inventory-cost-C2 * (x + (asset + asset - x) * beita)
          set asset  asset -(asset + asset - x) * beita - x
         ]
         [
          set income price * (asset - 0.5 * asset * beita) 
          set inventory (asset - asset * beita / 2) / 2
          set cost (order-fixed-cost-O / quantity + unit-purchase-cost-C1) * asset + unit-inventory-cost-C2 * asset
          set asset 0
         ]
       ]
      ]
  ]
end

to calculate-profit
  ask retailers
  [ 
     set profit profit + income - cost
     set reward income - cost
     set total-cost total-cost + cost
     if ticks > 0
     [set average-profit profit / ticks]    
  ]
  ask retailer 3
  [
    ifelse ticks mod 2 = 1
     [set reward_1 replace-item 0 reward_1 reward]
     [set reward_1 replace-item 1 reward_1 reward]
    ]
end
    
to replenish
  ask retailers with [asset -(asset + asset - x) * beita - x <= 0 or product-value < 0.2]
    [
      set asset quantity
      set time -1
      set order-1 order-1 + 1
    ]
end
  
to move
  move-to-space
end

to move-to-space
  ask customers with [color = red]
  [
  let dmax distance max-one-of retailers [distance myself]       ;distance agent
  let dmin distance min-one-of retailers [distance myself]
  let pmin min [price] of retailers
  let pmax max [price] of retailers
  let d30 distance retailer 0              
  let d31 distance retailer 1
  let d32 distance retailer 2
  let d33 distance retailer 3
  ask retailer 0        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d30 - dmin) / (dmax - dmin)
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-1-preference * utility-d + (1 - customer-1-preference) * utility-p]
  ask retailer 1        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d31 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-1-preference * utility-d + (1 - customer-1-preference) * utility-p]
  ask retailer 2        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d32 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-1-preference * utility-d + (1 - customer-1-preference) * utility-p]
  ask retailer 3        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d33 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-1-preference * utility-d + (1 - customer-1-preference) * utility-p]  
       
    move-to min-one-of retailers [utility]
  ]

  ask customers with [color = green]
  [
  let dmax distance max-one-of retailers [distance myself]       ;distance agent
  let dmin distance min-one-of retailers [distance myself]
  let pmin min [price] of retailers
  let pmax max [price] of retailers
  let d30 distance retailer 0              
  let d31 distance retailer 1
  let d32 distance retailer 2
  let d33 distance retailer 3
  ask retailer 0        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d30 - dmin) / (dmax - dmin)
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-2-preference * utility-d + (1 - customer-2-preference) * utility-p]
  ask retailer 1        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d31 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-2-preference * utility-d + (1 - customer-2-preference) * utility-p]
  ask retailer 2        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d32 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-2-preference * utility-d + (1 - customer-2-preference) * utility-p]
  ask retailer 3        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d33 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-2-preference * utility-d + (1 - customer-2-preference) * utility-p]  
       
    move-to min-one-of retailers [utility]
  ]

  ask customers with [color = blue]
  [
  let dmax distance max-one-of retailers [distance myself]       ;distance agent
  let dmin distance min-one-of retailers [distance myself]
  let pmin min [price] of retailers
  let pmax max [price] of retailers
  let d30 distance retailer 0              
  let d31 distance retailer 1
  let d32 distance retailer 2
  let d33 distance retailer 3
  ask retailer 0        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d30 - dmin) / (dmax - dmin)
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-3-preference * utility-d + (1 - customer-3-preference) * utility-p]
  ask retailer 1        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d31 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-3-preference * utility-d + (1 - customer-3-preference) * utility-p]
  ask retailer 2        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d32 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-3-preference * utility-d + (1 - customer-3-preference) * utility-p]
  ask retailer 3        ; this may be wrong ,because after"ask retailers", the distance is whose
    [set utility-d  (d33 - dmin) / (dmax - dmin)
    set utility-q product-value
    set utility-p (price - pmin) / (pmax - pmin)
    set utility customer-3-preference * utility-d + (1 - customer-3-preference) * utility-p]  
       
    move-to min-one-of retailers [utility]
  ]  
end
 

to leave
  ask customers
 [
   setxy random-xcor random-ycor
 ]
end

to Q-learning
 ask retailer 3
   [ifelse ticks < 2
   [let item_11 random 13
    set price item item_11 price-queue]
   [
     set price_1 price
     if price = 6
     [set pprice item 0 Q-table
      let Q_1 item 0 pprice
      let Q_2 item 1 pprice
      ifelse Q_1 = 0
      [ifelse Q_2 = 0
        [set possible_1 0.5 set possible_2 0.5]
        [set possible_1 possible set possible_2 (1 - possible)]
        ]
      [ifelse Q_2 = 0
        [set possible_1 (1 - possible) set possible_2 possible]
        [set possible_1 0.5 set possible_2 0.5]
        ]
      let rrandom random 100
      ifelse rrandom < possible_1 * 100
      [set price price]
      [let random_1 (12 - price) / 0.5
       let random_2 random random_1
       let random_3 random_2 + 1
       if random_3 > 3
       [set random_3  3]
       set price price + 0.5 * random_3]
      ]
     
     if price = 12
     [set pprice item 12 Q-table
      let Q_1 item 0 pprice
      let Q_2 item 1 pprice
      ifelse Q_1 = 0
      [ifelse Q_2 = 0
        [set possible_2 0.5 set possible_3 0.5]
        [set possible_2 possible set possible_3(1 - possible)]
        ]
      [ifelse Q_2 = 0
        [set possible_2 (1 - possible) set possible_3 possible]
        [set possible_2 0.5 set possible_3 0.5]
        ]
      let rrandom random 100
      ifelse rrandom < possible_2 * 100
      [let random_1 (price - 6) / 0.5
       let random_2 random random_1
       let random_3 random_2 + 1
       if random_3 > 3
       [set random_3 3]
       set price price - 0.5 * random_3]
      [set price price]      
     ]
      
     if price > 6 and price < 12
     [
       let iitem (price - 6) / 0.5
       set pprice item iitem Q-table
       let Q_1 item 0 pprice
       let Q_2 item 1 pprice
       let Q_3 item 2 pprice
       ifelse Q_1 = 0
       [ifelse Q_2 = 0
         [ifelse Q_3 = 0
           [set possible_1 0.33 set possible_2 0.33 set possible_3 0.33]
           [set possible_1 possible / 2 set possible_2 possible / 2 set possible_3 (1 - possible)]
           ]
         [ifelse Q_3 = 0
           [set possible_1 possible / 2 set possible_2 (1 - possible) set possible_3 possible / 2]
           [set possible_1 possible set possible_2 (1 - possible) * (exp Q_2 / (exp Q_2 + exp Q_3)) set possible_3 (1 - possible) * (exp Q_3 / (exp Q_2 + exp Q_3))]
           ]
         ]
       [ifelse Q_2 = 0
         [ifelse Q_3 = 0
           [set possible_1 (1 - possible) set possible_2 possible / 2 set possible_3 possible / 2]
           [set possible_1 (1 - possible) * (exp Q_1 / (exp Q_1 + exp Q_3)) set possible_2 possible set possible_3 (1 - possible) * (exp Q_3 / (exp Q_1 + exp Q_3))]
           ]
         [ifelse Q_3 = 0
           [set possible_1 (1 - possible) * (exp Q_1 / (exp Q_1 + exp Q_2)) set possible_2 (1 - possible) * (exp Q_2 / (exp Q_1 + exp Q_2)) set possible_3 possible]
           [set possible_1 exp Q_1 / (exp Q_1 + exp Q_2 + exp Q_3) set possible_2 exp Q_2 / (exp Q_1 + exp Q_2 + exp Q_3) set possible_3 exp Q_3 / (exp Q_1 + exp Q_2 + exp Q_3)]
           ]
         ]
        let rrandom random 100
        if rrandom < possible_1 * 100
        [let random_1 (price - 6) / 0.5
         let random_2 random random_1
         let random_3 random_2 + 1
         if random_3 > 3
          [set random_3 3]
         set price price - 0.5 * random_3]
        if rrandom >= possible_1 * 100 and rrandom < (possible_1 + possible_2) * 100
        [set price price]
        if rrandom >= (possible_1 + possible_2) * 100 
        [let random_1 (12 - price) / 0.5
         let random_2 random random_1
         let random_3 random_2 + 1
         if random_3 > 3
          [set random_3 3]
         set price price + 0.5 * random_3]
       ]
   ]
   ]      
end

to update-Q-table
  ask retailer 3
   [ifelse ticks > 1
    [ifelse ticks mod 2 = 0
     [let reward_2 item 0 reward_1
      let reward_3 item 1 reward_1
      set reward_4 reward_3 - reward_2]
     [let reward_2 item 0 reward_1
      let reward_3 item 1 reward_1
      set reward_4 reward_2 - reward_3]
    let iitem (price_1 - 6) / 0.5
    set ppprice item iitem Q-table
    
    let iitem_1 (price - 6) / 0.5
    let ppprice_1 item iitem_1 Q-table
    let ppprice_2 max ppprice
    
    
    if price_1 = 6
    [ifelse price_1 = price
      [let ppprice_3 item 0 ppprice 
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 0 ppprice ppprice_4]
      [let ppprice_3 item 1 ppprice 
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 1 ppprice ppprice_4]
      ]
    
    if price_1 = 12
    [ifelse price_1 = price
      [let ppprice_3 item 1 ppprice
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 1 ppprice ppprice_4]
      [let ppprice_3 item 0 ppprice
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 0 ppprice ppprice_4]
      ]
    
    if price_1 > 6 and price_1 < 12
    [if price_1 > price
      [let ppprice_3 item 0 ppprice
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 0 ppprice ppprice_4]
     if price_1 = price
      [let ppprice_3 item 1 ppprice
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 1 ppprice ppprice_4]
     if price_1 < price
      [let ppprice_3 item 2 ppprice
       let ppprice_4 (1 - learning-rate) * ppprice_3 + learning-rate * (reward_4 + discount-rate * ppprice_2)
       set ppprice replace-item 2 ppprice ppprice_4]
      ]
    
    
    set Q-table replace-item iitem Q-table ppprice
    
    ]
    [set Q-table Q-table]
   ]
end




    
    
    
@#$#@#$#@
GRAPHICS-WINDOW
231
10
670
470
16
16
13.0
1
10
1
1
1
0
1
1
1
-16
16
-16
16
0
0
1
ticks
30.0

BUTTON
64
10
130
43
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
142
10
205
43
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
99
74
202
107
customers-1
customers-1
0
100
40
2
1
NIL
HORIZONTAL

SLIDER
101
115
205
148
customers-2
customers-2
0
100
40
2
1
NIL
HORIZONTAL

SLIDER
100
152
205
185
customers-3
customers-3
0
100
40
2
1
NIL
HORIZONTAL

PLOT
701
335
923
494
profit
time
profit
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"profit-1" 1.0 0 -16777216 true "" "plot [profit] of retailer 0"
"profit-2" 1.0 0 -14439633 true "" "plot [profit] of retailer 1"
"profit-3" 1.0 0 -2064490 true "" "plot [profit] of retailer 2"
"profit-4" 1.0 0 -1184463 true "" "plot [profit] of retailer 3"

PLOT
933
10
1152
160
income
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"income-1" 1.0 0 -16777216 true "" "plot [income] of retailer 0"
"income-2" 1.0 0 -14439633 true "" "plot [income] of retailer 1"
"income-3" 1.0 0 -4757638 true "" "plot [income] of retailer 2"
"income-4" 1.0 0 -1184463 true "" "plot [income] of retailer 3"

PLOT
1156
10
1356
160
cost
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"cost-1" 1.0 0 -16777216 true "" "plot [cost] of retailer 0"
"cost-2" 1.0 0 -14439633 true "" "plot [cost] of retailer 1"
"cost-3" 1.0 0 -4757638 true "" "plot [cost] of retailer 2"
"cost-4" 1.0 0 -4079321 true "" "plot [cost] of retailer 3"

SLIDER
49
199
176
232
learning-rate
learning-rate
0
1
0.5
0.01
1
NIL
HORIZONTAL

SLIDER
50
234
176
267
discount-rate
discount-rate
0
1
0.4
0.01
1
NIL
HORIZONTAL

PLOT
700
172
924
328
asset
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"asset-1" 1.0 0 -16777216 true "" "plot [asset] of retailer 0"
"asset-2" 1.0 0 -14439633 true "" "plot [asset] of retailer 1"
"asset-3" 1.0 0 -4757638 true "" "plot [asset] of retailer 2"
"asset-4" 1.0 0 -4079321 true "" "plot [asset] of retailer 3"

PLOT
700
10
926
163
price
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"price-1" 1.0 0 -16777216 true "" "plot [price] of retailer 0"
"price-2" 1.0 0 -14439633 true "" "plot [price] of retailer 1"
"price-3" 1.0 0 -4757638 true "" "plot [price] of retailer 2"
"price-4" 1.0 0 -4079321 true "" "plot [price] of retailer 3"

PLOT
933
174
1153
325
product-value
NIL
NIL
0.0
10.0
0.9
1.1
true
true
"" ""
PENS
"product-value-1" 1.0 0 -16777216 true "" "plot [product-value] of retailer 0"
"product-value-2" 1.0 0 -14439633 true "" "plot [product-value] of retailer 1"
"product-value-3" 1.0 0 -4757638 true "" "plot [product-value] of retailer 2"
"product-value-4" 1.0 0 -1184463 true "" "plot [product-value] of retailer 3"

PLOT
1159
169
1397
361
average-profit
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"average-profit-1" 1.0 0 -16777216 true "" "plot [average-profit] of retailer 0"
"average-profit-2" 1.0 0 -13840069 true "" "plot [average-profit] of retailer 1"
"average-profit-3" 1.0 0 -2064490 true "" "plot [average-profit] of retailer 2"
"average-profit-4" 1.0 0 -1184463 true "" "plot [average-profit] of retailer 3"

PLOT
935
336
1154
493
total-cost
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"total-cost-1" 1.0 0 -16777216 true "" "plot [total-cost] of retailer 0"
"total-cost-2" 1.0 0 -14439633 true "" "plot [total-cost] of retailer 1"
"total-cost-3" 1.0 0 -2064490 true "" "plot [total-cost] of retailer 2"
"total-cost-4" 1.0 0 -1184463 true "" "plot [total-cost] of retailer 3"

SLIDER
50
269
142
302
possible
possible
0
1
0.8
1
1
NIL
HORIZONTAL

MONITOR
1158
336
1330
385
NIL
[order-1] of retailer 0
17
1
12

MONITOR
1158
387
1330
436
NIL
[order-1] of retailer 1
17
1
12

MONITOR
1160
438
1332
487
NIL
[order-1] of retailer 2
17
1
12

MONITOR
1161
490
1333
539
NIL
[order-1] of retailer 3
17
1
12

SLIDER
62
324
209
357
retailer-0-price
retailer-0-price
6
12
8
0.5
1
NIL
HORIZONTAL

SLIDER
62
358
209
391
retailer-1-price-1
retailer-1-price-1
0
10
4
1
1
NIL
HORIZONTAL

SLIDER
62
394
209
427
retailer-1-price-2
retailer-1-price-2
0
10
3
1
1
NIL
HORIZONTAL

SLIDER
61
429
209
462
retailer-2-price-1
retailer-2-price-1
0
10
6.5
0.5
1
NIL
HORIZONTAL

SLIDER
62
464
210
497
retailer-2-price-2
retailer-2-price-2
0
5
4
1
1
NIL
HORIZONTAL

SLIDER
3
74
95
107
customer-1-preference
customer-1-preference
0
1
0.8
0.1
1
NIL
HORIZONTAL

SLIDER
4
113
96
146
customer-2-preference
customer-2-preference
0
1
0.2
0.1
1
NIL
HORIZONTAL

SLIDER
4
150
96
183
customer-3-preference
customer-3-preference
0
1
0.5
0.1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.1.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
